> For the complete documentation index, see [llms.txt](https://docs.umbraco.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.umbraco.com/umbraco-cms/13.latest/reference/api-documentation.md).

# API Documentation

Information on Umbraco API Documentation

A library of API Reference documentation is auto-generated from the comments within the Umbraco Source Code.

## C# API Documentation

C# API references for the Umbraco Core, Infrastructure, Extensions and Web libraries.

### [Umbraco.Cms.Core](https://apidocs.umbraco.com/v13/csharp/api/Umbraco.Cms.Core.html)

### [Umbraco.Cms.Infrastructure](https://apidocs.umbraco.com/v13/csharp/api/Umbraco.Cms.Infrastructure.html)

### [Umbraco.Cms.Web](https://apidocs.umbraco.com/v13/csharp/api/Umbraco.Cms.Web.Common.html)

### [Umbraco.Extensions](https://apidocs.umbraco.com/v13/csharp/api/Umbraco.Extensions.html)

{% hint style="info" %}
Opens a documentation browser that is different from the documentation section you're viewing now.
{% endhint %}

## Backoffice UI API Documentation

Angular, JavaScript, CSS & Less UI API references for building Umbraco backoffice components.

* The umbraco.directives
* The umbraco.services
* The umbraco.resources

### [Backoffice UI](https://apidocs.umbraco.com/v13/ui/)

{% hint style="info" %}
Opens a documentation browser that is different from the documentation section you're viewing now.
{% endhint %}


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.umbraco.com/umbraco-cms/13.latest/reference/api-documentation.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
